// MainWindow.h
// アプリケーションのメインウィンドウ全般の基底クラス
// ウィンドウが閉じられたときにアプリケーションに終了要求を出す

#ifndef MAIN_WINDOW_H_
#define MAIN_WINDOW_H_

#include <Application.h>
#include <Window.h>

class TMainWindow : public BWindow
{
public:

	TMainWindow(BRect _rect,const char* _name,
				window_type _type,uint32 _flags,
				uint32 _workspaces = B_CURRENT_WORKSPACE)
			:BWindow(_rect,_name,_type,_flags,_workspaces) {}

	TMainWindow(BRect _rect,const char* _name,
				window_look _look,window_feel _feel,
				uint32 _flags,
				uint32 _workspaces = B_CURRENT_WORKSPACE)
			:BWindow(_rect,_name,_look,_feel,_flags,_workspaces) {}

	TMainWindow(BMessage* _message) : BWindow(_message) {}

	// アプリケーションに終了要求を出す
	virtual bool QuitRequested();	
};


#endif // MAIN_WINDOW_H_